commit 9e1ed25052046561225e7a95a7631885b05cfb8e
Author: freddy77 <freddy77>
Date:   Wed Nov 5 19:23:32 2008 +0000

    reduce a roundtrip, improve freeclose test

diff --git a/ChangeLog b/ChangeLog
index d5d781f..2bb740b 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Wed Nov 05 20:21:29 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c src/odbc/unittests/freeclose.c:
+	- reduce one round-trip with server
+	- improve freeclose test to detect complete rebindings
+	- use always cursor results if cursor used
+
 Wed Nov 05 15:54:26 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h src/tds/mem.c src/tds/token.c:
 	- remove warning
@@ -893,4 +899,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2651 2008/11/05 14:54:41 freddy77 Exp $
+$Id: ChangeLog,v 1.2652 2008/11/05 19:23:32 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 06b19dc..2ba97b9 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.504 2008/11/04 15:24:49 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.505 2008/11/05 19:23:32 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -4248,6 +4248,7 @@ SQLPrepare(SQLHSTMT hstmt, SQLCHAR FAR * szSqlStr, SQLINTEGER cbSqlStr)
 		TDSPARAMINFO *params = NULL;
 		TDSSOCKET *tds = stmt->dbc->tds_socket;
 
+		stmt->need_reprepare = 0;
 		/*
 		 * using TDS7+ we need parameters to prepare a query so try
 		 * to get them 
@@ -4683,9 +4684,7 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 	tds = stmt->dbc->tds_socket;
 	context = stmt->dbc->env->tds_ctx;
 
-	resinfo = tds->current_results;
-	if (stmt->cursor && stmt->cursor->res_info)
-		resinfo = stmt->cursor->res_info;
+	resinfo = stmt->cursor ? stmt->cursor->res_info : tds->current_results;
 	if (!resinfo) {
 		odbc_errs_add(&stmt->errs, "HY010", NULL);
 		ODBC_RETURN(stmt, SQL_ERROR);
diff --git a/src/odbc/unittests/freeclose.c b/src/odbc/unittests/freeclose.c
index 3e8422e..3f56323 100644
--- a/src/odbc/unittests/freeclose.c
+++ b/src/odbc/unittests/freeclose.c
@@ -50,7 +50,7 @@
 
 #include "tds.h"
 
-static char software_version[] = "$Id: freeclose.c,v 1.8 2008/11/04 14:46:17 freddy77 Exp $";
+static char software_version[] = "$Id: freeclose.c,v 1.9 2008/11/05 19:23:33 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 /* this crazy test test that we do not send too much prepare ... */
@@ -327,24 +327,57 @@ main(int argc, char **argv)
 	CHKBindParameter(2, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, sizeof(string), 0, string, 0, &sql_nts, "SI");
 
 	CHKPrepare((SQLCHAR *) query, SQL_NTS, "SI");
+	printf("%u round trips %u inserts\n", round_trips, inserts);
+
 	for (id = 0; id < num_inserts; id++) {
 		sprintf(string, "This is a test (%d)", (int) id);
 		CHKExecute("SI");
 		CHKFreeStmt(SQL_CLOSE, "S");
 	}
 
+	printf("%u round trips %u inserts\n", round_trips, inserts);
 	ResetStatement();
 
-	Disconnect();
+	if (inserts > 1 || round_trips > num_inserts * 2 + 6) {
+		fprintf(stderr, "Too much round trips (%u) or insert (%u) !!!\n", round_trips, inserts);
+		return 1;
+	}
+	printf("%u round trips %u inserts\n", round_trips, inserts);
 
-	alarm(10);
-	pthread_join(fake_thread, NULL);
+#ifdef ENABLE_DEVELOPING
+	/* check for SQL_RESET_PARAMS */
+	round_trips = 0;
+	inserts = 0;
+
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, sizeof(id), 0, &id, 0, &sql_nts, "SI");
+	CHKBindParameter(2, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, sizeof(string), 0, string, 0, &sql_nts, "SI");
 
-	if (inserts > 2 || round_trips > num_inserts * 2 + 10) {
+	CHKPrepare((SQLCHAR *) query, SQL_NTS, "SI");
+	printf("%u round trips %u inserts\n", round_trips, inserts);
+
+	for (id = 0; id < num_inserts; id++) {
+		CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, sizeof(id), 0, &id, 0, &sql_nts, "SI");
+		CHKBindParameter(2, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, sizeof(string), 0, string, 0, &sql_nts, "SI");
+
+		sprintf(string, "This is a test (%d)", (int) id);
+		CHKExecute("SI");
+		CHKFreeStmt(SQL_RESET_PARAMS, "S");
+	}
+
+	printf("%u round trips %u inserts\n", round_trips, inserts);
+	ResetStatement();
+
+	if (inserts > 1 || round_trips > num_inserts * 2 + 6) {
 		fprintf(stderr, "Too much round trips (%u) or insert (%u) !!!\n", round_trips, inserts);
 		return 1;
 	}
 	printf("%u round trips %u inserts\n", round_trips, inserts);
+#endif
+
+	Disconnect();
+
+	alarm(10);
+	pthread_join(fake_thread, NULL);
 
 	return 0;
 }

